<template>
  <span :id="id">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || (field.textType && field.textType == 'hidden')"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->

      <input type="hidden" v-model="field.value" />
      <div class="image-upload" v-if="field.mobile&&field.hiddenValue">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
        </div>
        <div class="view-li">
          <div class="view-li-right">
            {{field.hiddenValue}}
          </div>
        </div>
      </div>
    </template>

    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <div class="image-upload" v-if="field.mobile">
        <div class="titleName">
        {{field.discript?field.discript:field.name}}
         <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
        </div>
        <div class="pic-wrap">
          <div class="fileCon">
            <div class="list" v-if="field.value">
              <div v-for="(item,index) in field.value" :key="index">
                <div class="close" @click="close(index, item.path)">
                  <img src="../assets/images/delect.png" alt />
                </div>
                <img :src="field.picUrl+item.path" @click="picturePreview(item.path,index)"/>
              </div>
              <div class="add" v-show="maxStatus" @click="chooseType">
                <div class="add-image">
                  <img src="../assets/images/upload2.png"/>
                </div>
              </div>
            </div>
            <div class="list" v-else>
              <div class="add" v-show="maxStatus" @click="chooseType">
                <div class="add-image">
                  <img src="../assets/images/upload2.png"/>
                </div>
              </div>
            </div>
          </div>
          <input
            :id="field.divId"
            type="file"
            class="file-input"
            accept="image/png, image/jpeg, image/jpg"
            :multiple="multiple"
            @change="inputChange"
            style="display: none"
          />
        </div>
      </div>
    </template>

    <template
      v-else-if="field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED"
    >
      <template v-if="field.readOnlyShowValOnly">
        <div class="image-upload" v-if="field.mobile">
          <div class="titleName">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>  
          </div>
          <div class="pic-wrap">
            <div class="fileCon">
              <div class="list" v-if="field.value">
                <div v-for="(item,index) in field.value" :key="index">
                  <img :src="field.picUrl+item.path" @click="picturePreview(item.path,index)"/>
                </div>
              </div>
            </div>
            <input
              :id="field.divId"
              type="file"
              class="file-input"
              accept="image/png, image/jpeg, image/jpg"
              :multiple="multiple"
              style="display: none"
            />
          </div>
        </div>
      </template>

      <template v-else>
        <div class="image-upload" v-if="field.mobile">
          <div class="titleName">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>  
          </div>
          <div class="pic-wrap">
            <div class="fileCon">
              <div class="list" v-if="field.value">
                <div v-for="(item,index) in field.value" :key="index">
                  <div class="close" @click="close(index, item.path)">
                    <img src="../assets/images/delect.png" alt />
                  </div>
                  <img :src="field.picUrl+item.path" @click="picturePreview(item.path,index)"/>
                </div>
              </div>
              <div class="list">
                <div class="add" v-show="maxStatus">
                  <div class="add-image">
                    <img src="../assets/images/upload.png" />
                  </div>
                </div>
              </div>
            </div>
            <input
              :id="field.divId"
              type="file"
              class="file-input"
              accept="image/png, image/jpeg, image/jpg"
              :multiple="multiple"
              style="display: none"
            />
          </div>
        </div>
      </template>
    </template>
    <mt-popup
      v-model="dialogVisible"
      :closeOnClickModal = "false"
      style="width:50%;border-radius:5px;"
      >
      <div style="display:flex;flex-direction:row;justify-content:center;align-items:center;padding:20px 0;">
        <mt-spinner :type="3" color="#26a2ff" :size="20"></mt-spinner>
        <span style="margin-left:10px;">{{$t('uploading')}}</span>
      </div>
    </mt-popup>
    <van-image-preview v-model="popupVisible" :images="imgList" closeable :start-position="currentPreviewImg"></van-image-preview>
  </span>
</template>

<script>
import wx from "weixin-js-sdk"
import { Toast } from 'mint-ui';
import Constant from "@/Constant.js";
import API from "@/api.js";
export default {
  name: "o-image-upload",
  props: ["id"],
  computed: {
    field: function() {
      let formData = this.$parent.findField(this.id);
      if(formData.discript) {//识别控件描述最后一个字符为*时，*变红
        if(formData.discript.charAt(formData.discript.length - 1) == "*") {
          formData.discript = formData.discript.replace(/(\s|\*)+$/g, '');
          formData.essential = true;
        }
      }
      if(formData.value && formData.value.length>0) {
        if(typeof formData.value == 'string') {
          formData.value = JSON.parse(formData.value);
        }else {
          formData.value = formData.value;//选项卡返回的是数组
        }
      }else {
        formData.value = [];
      }
      formData.picUrl = obpmConfig.obpmFilePath;
      return formData;
    }
  },
  data: function() {
    return {
      Constant,
      dialogImageUrl: "",
      dialogVisible: false,
      imageType: "",
      maxStatus: true,
      multiple: true,
      list: [],
      picUrl: "",
      bigPic:"",
      popupVisible:false,
      fileSize:0,
      partialRefreshData:[],
      imgList: [],
	  currentPreviewImg: 0, //预览时显示当前点击的照片
    };
  },
  methods: {
    //图片预览
    picturePreview(filePath,index){
	    this.currentPreviewImg = index
      // this.bigPic = obpmConfig.obpmFilePath + filePath;
      let picList = this.field.value
      let accessToken = localStorage.getItem("accessToken");
      if(picList.length > 0) {
        let list = [];
        picList.forEach(el => {
          let path = obpmConfig.obpmFilePath + el.path + "?accessToken="+ accessToken; //嗨办公预览破图，加上token
          list.push(path);
        });
        this.imgList = list;
      }
      this.popupVisible = true;
    },

    chooseType() {
      let that = this;
      let ua = window.navigator.userAgent;
      if (ua.toLowerCase().indexOf("wxwork") >= 0 || ua.toLowerCase().indexOf("weixin") >= 0){
        let _url = location.href.split("#")[0];
        let maxLength = this.field.limitNumber; //最大上传数量 
        API.getWeixinApi(
          encodeURIComponent(_url),
          {
            onSucess: response => {
              wx.config({
                debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
                appId: response.data.data.appId, // 必填，公众号的唯一标识
                timestamp: response.data.data.timestamp, // 必填，生成签名的时间戳
                nonceStr: response.data.data.nonceStr, // 必填，生成签名的随机串
                signature: response.data.data.signature, // 必填，签名，见附录1
                jsApiList: [
                  "chooseImage",
                  "previewImage",
                  "uploadImage",
                  "downloadImage",
                ] // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
              });

              wx.chooseImage({
                count: maxLength,
                sizeType: ["original", "compressed"], // o：原图，c：压缩图
                sourceType: ["album", "camera"], // a：来自相册，c：来自相机
                success: function(res) {
                  let r = JSON.stringify(res)
                  that.uploadFile(res.localIds);
                },
                fail: function(error) {
                  alert("网络异常，请再次尝试！");
                }
              });
            }
          }
        );
      }else {
        document.getElementById(this.field.divId).click();
      }
    },

    uploadFile(id) {
      let that = this;
      for(let i = 0; i < id.length; i++) {
        wx.uploadImage({
          localId: id[i],
          isShowProgressTips: 1,// 默认为1，显示进度提示
          success: function (res) {
            let serverId = res.serverId;
            that.$api.uploadWeixinPhoto(serverId,{
              onSucess: (response) => {
                if(response.data.data) {
                  let val = response.data.data;
                  let valArr = val.split("/")
                  that.picUrl = obpmConfig.obpmFilePath +"/";
                  let obj = {
                    name: valArr[valArr.length - 1],
                    path: val,
                  };
                  that.field.value.push(obj);
                  // let val = response.data.data;
                  // that.photoURL.push(val);
                  // that.field.value = that.photoURL;
                }
              }
            });
          },
          fail: function () {
            alert("网络异常，请再次尝试！");
          }
        });
      }
    },

    close(index, item) {
      // this.list.splice(index, 1);
      // this.maxStatus = this.list == this.max ? false : true;
      this.partialRefreshData = [];
      let appId = this.$root.appid;
      let formId = this.field.formId;
      let docId = this.field.docId;
      let path = item;
      API.deleteUpload(appId, formId, docId, path, {
        onSucess: () => {
          this.field.value.splice(index, 1);
          this.maxStatus = this.field.value.length == this.field.limitNumber ? false : true;
          if (this.field.refreshOnChanged){
            this.$parent.refresh(this.field.id);
          }
        }
      });
    },

    async inputChange(e) {
      let files = e.target.files;
      for(let i=0; i<e.target.files.length; i++) {
        this.fileSize = e.target.files[i].size
      }

      //限制大小
      if(this.fileSize/1024 > this.field.maxsize) {
        document.getElementById(this.field.divId).value = "";
        let size = this.field.maxsize / 1024
        this.$toast(`上传图片大小不能超过${size}M`);
        this.fileSize = 0;
        return;
      }

      //限制上传数量
      let len = this.field.value.length + files.length;
      let maxLength = this.field.limitNumber; //最大上传数量 
      if (len >  maxLength) {
        document.getElementById(this.field.divId).value = "";
        //alert(`最多允许上传${this.max}张`);
        this.$toast(`最多允许上传${maxLength}张图片`);
        return;
      }
      this.dialogVisible = true;
      [].slice.call(files, 0).map(this.upload);
      //let result = await Promise.all(uploadAll);
      document.getElementById(this.field.divId).value = "";
    },

    upload(file) {
      let nameArr = file.name.split(".");
      let name = nameArr[nameArr.length -1];
      let smallName = name.toLowerCase() //把后缀名转为小写，兼容苹果手机
      let arr = ['jpeg','png','gif','jpg'];
      let isSuffix = arr.indexOf(smallName) != -1;
      if(!isSuffix) {
        this.dialogVisible = false;
        Toast("图片类型错误");
        return
      }
      let that = this;
      return new Promise(async () => {
        let form = new FormData();
        form.append("files", file);
        let files = form;
        let actionType = this.imageType;
        let appId = this.$root.appid;
        let allowedTypes = this.field.fileType;
        let fieldId = this.id;
        let fileSaveMode = this.field.fileSaveMode;
        let path = this.field.path;
        this.$api.uploadFile(
          files, 
          appId, 
          allowedTypes,  
          fieldId, 
          fileSaveMode, 
          path, 
          actionType,
          {
            onSucess: response => {
              that.picUrl = obpmConfig.obpmFilePath +"/";
              let obj = {
                name: response.data.data[0].fileName,
                path: response.data.data[0].filePath,
              };
              
              that.field.value.push(obj);
              that.dialogVisible = false;
              if (that.field.refreshOnChanged){
                let havePar = false;
                let par  = '';
                while(!havePar) {
                  par = par + '.$parent';
                  let url = 'that' + par + '.refresh';
                  if(eval(url)) {
                    let path = url + '(' + "'"+ this.id +"'" + ')';
                    eval(path);
                    break
                  }
                }
                // that.$parent.refresh(that.id);
              }
             
            }
          }
        )
      });
    }
  }
};
</script>
